--[[
    https://wow.gamepedia.com/API_Frame_SetClampedToScreen
    https://github.com/tomrus88/BlizzardInterfaceCode/blob/master/Interface/FrameXML/GameTooltip.lua#L159-L162
]]

local ANCHOR_TO_MOUSE = true

-- Disable FadeOut animation on UnitFrame
-- It only works correctly if the anchor is "ANCHOR_NONE"
local function fadeOut(self)
    if ANCHOR_TO_MOUSE then
        self:Hide()
    else
        if InCombatLockdown() then
            self:Hide()
        end
    end
end

local function setDefaultAnchor(self, parent)
    if not InCombatLockdown() then
        if ANCHOR_TO_MOUSE then
            if GetMouseFocus() == WorldFrame then
                self:SetOwner(parent, 'ANCHOR_CURSOR_LEFT')
            end
        else
            self:SetOwner(parent, 'ANCHOR_NONE')
        end
    else
        -- Disable FadeOut animation on WorldFrame by using "ANCHOR_CURSOR"
        self:SetOwner(parent, GetMouseFocus() == WorldFrame and 'ANCHOR_CURSOR' or 'ANCHOR_NONE')
        self:ClearAllPoints()
        self:SetPoint('BOTTOMRIGHT', UIParent, 'BOTTOMRIGHT', -CONTAINER_OFFSET_X - 13, CONTAINER_OFFSET_Y)
    end
end

hooksecurefunc(GameTooltip, 'FadeOut', fadeOut)
hooksecurefunc('GameTooltip_SetDefaultAnchor', setDefaultAnchor)