--[[
    https://github.com/tomrus88/BlizzardInterfaceCode/blob/master/Interface/SharedXML/SharedColorConstants.lua
]]

local LS_SPELL_ID_TEXT = GetLocale() == 'ruRU' and 'ID заклинания: ' or 'Spell ID ' -- localized string

local function addLine(tooltip, id)
    if id then
        tooltip:AddLine(ORANGE_FONT_COLOR_CODE .. LS_SPELL_ID_TEXT .. FONT_COLOR_CODE_CLOSE .. id, 1, 1, 1)
        tooltip:Show() -- update borders correctly
    end
end

-- Spellbook, Talents
local function onTooltipSetSpell(self)
    local id = select(2, self:GetSpell()) -- 3

    -- Fix PlayerTalentFrame bug (duplicate line)
    for i = self:NumLines(), 3, -1 do
        local lineText = _G[self:GetName() .. 'TextLeft' .. i]:GetText()

        -- If the "Spell ID" line is found
        if string.match(lineText, LS_SPELL_ID_TEXT) then
            return -- stop the loop and exit the function
        end
    end
    -- If the "Spell ID" line is not found, a new one will be added
    addLine(self, id)
end

-- BuffFrame, UnitFrame
local function setUnitAura(self, unit, index, filter)
    local id = select(10, UnitAura(unit, index, filter)) -- 11

    addLine(self, id)
end

GameTooltip:HookScript('OnTooltipSetSpell', onTooltipSetSpell)
hooksecurefunc(GameTooltip, 'SetUnitAura', setUnitAura)
hooksecurefunc(GameTooltip, 'SetUnitBuff', setUnitAura)
hooksecurefunc(GameTooltip, 'SetUnitDebuff', setUnitAura)